import QtQuick
import QtQuick.Controls
import QtQuick.Layouts

import Core
import I18n
import Dialog

import "../core"
import "../widgets"

BaseForm {
    id: root
    objectName: "cardInfoForm"
    Style.class: "cardInfoForm"

    property var action: DialogState.actions[Context.id.value]

    contentItem: GridLayout {
        objectName: "mainLayout"
        columns: 1
        rowSpacing: 40

        ColumnLayout {
            objectName: "cardInfoLayout"
            spacing: 30

            SLabel {
                objectName: "cardInfoTitle"
                Style.class: "cardInfoTitle"
                Tr { code: "cardInfoTitle" }

                Layout.fillWidth: true
            }

            SGroupBox {
                objectName: "cardInfoBox"
                padding: 40

                contentItem: Item {
                    ColumnLayout {
                        objectName: "cardInfoCardLayout"
                        spacing: 40

                        Repeater {
                            model: [
                                { trCode: "cardInfoClientName", value: action.clientName },
                                { trCode: "cardInfoClientPhoneNumber", value: action.phoneNumber },
                                { trCode: "cardInfoClientEmail", value: action.clientEmail },
                                { trCode: "cardInfoCardNumber", value: action.number }
                            ]
                            delegate: ColumnLayout {
                                spacing: 8
                                visible: modelData.value

                                SLabel {
                                    objectName: "cardInfoListElementName"
                                    Style.class: "cardInfoListElementName"
                                    Tr { code: modelData.trCode }

                                    Layout.fillWidth: true
                                }
                                SLabel {
                                    objectName: "cardInfoListElementValue"
                                    Style.class: "cardInfoListElementValue"
                                    text: modelData.value

                                    Layout.fillWidth: true
                                }
                            }
                        }
                    }
                }

                Layout.fillHeight: true
                Layout.fillWidth: true
            }
        }

        ActionButton {
            objectName: "cardInfoCloseButton"
            Style.class: "cardInfoCloseButton"
            Tr { code: "cardInfoClose" }
            onClicked: removeContext()

            Layout.fillWidth: true
            Layout.preferredHeight: 80
        }
    }
}
